/*	commsel.c

	enumerate COMx:
	select COMx:

	Copyright (C) CPI Technologies, Inc.
*/

#define	BFL_ENABLE_IF_DISABLED		FALSE
/*
0	foCXĂΎgpsƂ݂Ȃ܂B
else	foCXĂΗL݂܂B
	Lɐ炻̃foCXgp\Ƃ݂Ȃ܂B
*/

/*//////////////////////////////////////////////////////////////////////
*/

#pragma	warning( disable: 4115 4201 4214 4514 )
#include <windows.h>
#pragma	warning( 1: 4115 4201 4214 )
#include <tchar.h>

#include <guiddef.h>
#include <cfgmgr32.h>
#pragma	warning( disable: 4201 )
#include <setupapi.h>
#pragma	warning( 1: 4201 )

#include <assert.h>

#include "tchars.h"

#include "commsel.h"

/*//////////////////////////////////////////////////////////////////////
*/

#define	N_CTRLS		4

#define	CC_ATOM_FOLLOWS	0xffff
#define	AC_BUTTON	0x0080
#define	AC_EDIT		0x0081
#define	AC_STATIC	0x0082
#define	AC_LISTBOX	0x0083
#define	AC_SCROLLBAR	0x0084
#define	AC_COMBOBOX	0x0085

#define	LID_JPN		0x0411

#define	IDC_STAT_COMM_SEL	0x2000
#define	IDC_LIST_COMM_SEL	0x2001

#define	ST_DLG		( 0	\
		| DS_MODALFRAME \
		| DS_CENTER	\
		| DS_SETFONT	\
		| WS_POPUP	\
		| WS_CAPTION	\
		| WS_SYSMENU	\
		)

#define	ST_STAT_COMM_SEL	( 0	\
		| WS_CHILD	\
		| WS_VISIBLE	\
		| SS_LEFT	\
		)

#define	ST_LIST_COMM_SEL	( 0	\
		| WS_CHILD	\
		| WS_TABSTOP	\
		| WS_VISIBLE	\
		| WS_VSCROLL	\
		| LBS_NODATA	\
		| LBS_SORT	\
		| LBS_STANDARD	\
		| LBS_NOINTEGRALHEIGHT	\
		)

#define	ST_BUTN_OK	( 0	\
		| WS_CHILD	\
		| WS_TABSTOP	\
		| WS_VISIBLE	\
		| BS_DEFPUSHBUTTON	\
		)

#define	ST_BUTN_CAN	( 0	\
		| WS_CHILD	\
		| WS_TABSTOP	\
		| WS_VISIBLE	\
		| BS_PUSHBUTTON \
		)

#define	LENGTH_OF( ar )		( sizeof ( ar ) / sizeof ( *ar ) )

#define	DSCT( id, st )		static TCHAR const id[] = _T( st )

/*//////////////////////////////////////////////////////////////////////
*/

typedef	struct
{
	LPCTSTR pszDlg;		/* dialog caption. */
	LPCTSTR pszList;	/* listbox label. */
}	TMES;

typedef	TMES FAR*	LPMES;

/*//////////////////////////////////////////////////////////////////////
*/

static	INT_PTR CALLBACK cb_dlg( HWND hd, UINT uM, WPARAM wP, LPARAM lP );

/*//////////////////////////////////////////////////////////////////////
*/

DSCT( s_szComm,		"COM" );

DSCT( s_szENoCommEnu,	"No communication port found." );
DSCT( s_szENoCommJpn,	"ʐM|[g܂łB" );

DSCT( s_szENoMemEnu,	"Not enoguth memory." );

DSCT( s_szDlgEnu,	"Communication Port Selection" );
DSCT( s_szDlgJpn,	"ʐM|[gI" );
DSCT( s_szListEnu,	"&Select communication port..." );
DSCT( s_szListJpn,	"ʐM|[gIĂ(&S)..." );

DSCT( s_szUnitDlgEnu,	"Coordinator Selection" );
DSCT( s_szUnitDlgJpn,	"R[fBl[^I" );
DSCT( s_szUnitListEnu,
	"&Select communication port that coordinator is connected..."
	);
DSCT( s_szUnitListJpn,
	"R[fBl[^ڑĂʐM|[gIĂ(&S)..."
	);

	/*
	// DDK̃CuNƒq̂EEE
	*/

static	GUID GUID_DEVCLASS_PORTS	=
{
	0x4d36e978L, 0xe325, 0x11ce,
	0xbf, 0xc1, 0x08, 0x00, 0x2b, 0xe1, 0x03, 0x18
};

static	WORD s_awEnu[]	=
{
	/*//////////////////////////////////////////////////////////////
	// define a dialog box.
	*/

	LOWORD( ST_DLG ),		/* style */
	HIWORD( ST_DLG ),

	LOWORD( 0 ),			/* dwExtendedStyle */
	HIWORD( 0 ),

	N_CTRLS,			/* cdit */

	0,				/* x */
	0,				/* y */
	200,				/* cx */
	171,				/* cy */

	0,				/* no menu */

					/* class: predefined dialog */
	0,				/* box ( by default ) */

					/* title */
	L'\0',				/* end of string */

#if	( DS_SETFONT & ST_DLG )	/*[*/

	8,				/* pitch */

	L'M',				/* face name */
	L'S',
	L' ',
	L'S',
	L'a',
	L'n',
	L's',
	L' ',
	L'S',
	L'e',
	L'r',
	L'i',
	L'f',
	L'\0',				/* end of string */

	0,				/* what ? */

#endif	/*]*/

	/*//////////////////////////////////////////////////////////////
	// define a static text.
	*/

	LOWORD( ST_STAT_COMM_SEL ),	/* style */
	HIWORD( ST_STAT_COMM_SEL ),

	LOWORD( 0 ),			/* dwExtendedStyle */
	HIWORD( 0 ),

	6,				/* x */
	6,				/* y */
	194,				/* cx */
	8,				/* cy */

	IDC_STAT_COMM_SEL,		/* id */

	CC_ATOM_FOLLOWS,		/* class: specify atom */
	AC_STATIC,			/* atom: static class */

	/*
	// O̕ł̓_Ȃ悤łB
	// ĂDialogBoxIndirectnO悤ɂȂ悤łB
	// WM_INITDIALOGŐݒ肷邱Ƃɂ܂B
	*/
	L'$',				/* text */
	L'\0',				/* end of string */

	0,				/* no creation data */

	/*//////////////////////////////////////////////////////////////
	// define a listbox.
	*/

	LOWORD( ST_LIST_COMM_SEL ),	/* style */
	HIWORD( ST_LIST_COMM_SEL ),

	LOWORD( 0 ),			/* dwExtendedStyle */
	HIWORD( 0 ),

	6,				/* x */
	18,				/* y */
	186,				/* cx */
	120,				/* cy */

	IDC_LIST_COMM_SEL,		/* id */

	CC_ATOM_FOLLOWS,		/* class: specify atom */
	AC_LISTBOX,			/* atom: listbox class */

	/* window text ? */
	L'\0',				/* end of string */

	0,				/* no creation data */

	0,				/* empty list ? */

	/*//////////////////////////////////////////////////////////////
	// define an OK button.
	*/

	LOWORD( ST_BUTN_OK ),		/* style */
	HIWORD( ST_BUTN_OK ),

	LOWORD( 0 ),			/* dwExtendedStyle */
	HIWORD( 0 ),

	96,				/* x */
	144,				/* y */
	48,				/* cx */
	18,				/* cy */

	IDOK,				/* id */

	CC_ATOM_FOLLOWS,		/* class: specify atom */
	AC_BUTTON,			/* atom: button class */

	/*
	// O̕ł͓삵܂B
	// WS_TABSTOPƃANZ[^e[u
	// 쐬Kv邩H
	*/
	L'&',				/* label */
	L'O',
	L'K',
	L'\0',				/* end of string */

	0,				/* no creation data */

	/*//////////////////////////////////////////////////////////////
	// define a Cancel button.
	*/

	LOWORD( ST_BUTN_CAN ),		/* style */
	HIWORD( ST_BUTN_CAN ),

	LOWORD( 0 ),			/* dwExtendedStyle */
	HIWORD( 0 ),

	144,				/* x */
	144,				/* y */
	48,				/* cx */
	18,				/* cy */

	IDCANCEL,			/* id */

	CC_ATOM_FOLLOWS,		/* class: specify atom */
	AC_BUTTON,			/* atom: button class */

	L'&',				/* label */
	L'C',
	L'a',
	L'n',
	L'c',
	L'e',
	L'l',
	L'\0',				/* end of string */

	0,				/* no creation data */

	/*//////////////////////////////////////////////////////////////
	// sv
	*/

	0
};

static	WORD s_awJpn[]	=
{
	/*//////////////////////////////////////////////////////////////
	// define a dialog box.
	*/

	LOWORD( ST_DLG ),		/* style */
	HIWORD( ST_DLG ),

	LOWORD( 0 ),			/* dwExtendedStyle */
	HIWORD( 0 ),

	N_CTRLS,			/* cdit */

	0,				/* x */
	0,				/* y */
	200,				/* cx */
	171,				/* cy */

	0,				/* no menu */

					/* class: predefined dialog */
	0,				/* box ( by default ) */

					/* title */
	L'\0',				/* end of string */

#if	( DS_SETFONT & ST_DLG )	/*[*/

	9,				/* pitch */

	L'l',				/* face name */
	L'r',
	L' ',
	L'o',
	L'S',
	L'V',
	L'b',
	L'N',
	L'\0',				/* end of string */

#endif	/*]*/

	/*//////////////////////////////////////////////////////////////
	// define a static text.
	*/

	LOWORD( ST_STAT_COMM_SEL ),	/* style */
	HIWORD( ST_STAT_COMM_SEL ),

	LOWORD( 0 ),			/* dwExtendedStyle */
	HIWORD( 0 ),

	6,				/* x */
	6,				/* y */
	194,				/* cx */
	8,				/* cy */

	IDC_STAT_COMM_SEL,		/* id */

	CC_ATOM_FOLLOWS,		/* class: specify atom */
	AC_STATIC,			/* atom: static class */

	/*
	// O̕ł̓_Ȃ悤łB
	// ĂDialogBoxIndirectnO悤ɂȂ悤łB
	// WM_INITDIALOGŐݒ肷邱Ƃɂ܂B
	*/
	L'$',				/* text */
	L'\0',				/* end of string */

	0,				/* no creation data */

	/*//////////////////////////////////////////////////////////////
	// define a listbox.
	*/

	LOWORD( ST_LIST_COMM_SEL ),	/* style */
	HIWORD( ST_LIST_COMM_SEL ),

	LOWORD( 0 ),			/* dwExtendedStyle */
	HIWORD( 0 ),

	6,				/* x */
	18,				/* y */
	186,				/* cx */
	120,				/* cy */

	IDC_LIST_COMM_SEL,		/* id */

	CC_ATOM_FOLLOWS,		/* class: specify atom */
	AC_LISTBOX,			/* atom: listbox class */

					/* window text ? */
	L'\0',				/* end of string */

	0,				/* no creation data */

	0,				/* empty list ? */

	/*//////////////////////////////////////////////////////////////
	// define an OK button.
	*/

	LOWORD( ST_BUTN_OK ),		/* style */
	HIWORD( ST_BUTN_OK ),

	LOWORD( 0 ),			/* dwExtendedStyle */
	HIWORD( 0 ),

	96,				/* x */
	144,				/* y */
	48,				/* cx */
	18,				/* cy */

	IDOK,				/* id */

	CC_ATOM_FOLLOWS,		/* class: specify atom */
	AC_BUTTON,			/* atom: button class */

	/*
	// O̕ł͓삵܂B
	// WS_TABSTOPƃANZ[^e[u
	// 쐬Kv邩H
	*/
	L'&',				/* label */
	L'O',
	L'K',
	L'\0',				/* end of string */

	0,				/* no creation data */

	/*//////////////////////////////////////////////////////////////
	// define a Cancel button.
	*/

	LOWORD( ST_BUTN_CAN ),		/* style */
	HIWORD( ST_BUTN_CAN ),

	LOWORD( 0 ),			/* dwExtendedStyle */
	HIWORD( 0 ),

	144,				/* x */
	144,				/* y */
	48,				/* cx */
	18,				/* cy */

	IDCANCEL,			/* id */

	CC_ATOM_FOLLOWS,		/* class: specify atom */
	AC_BUTTON,			/* atom: button class */

	L'L',				/* label */
	L'',
	L'',
	L'Z',
	L'',
	L'(',
	L'&',
	L'C',
	L')',
	L'\0',				/* end of string */

	0,				/* no creation data */

	/*//////////////////////////////////////////////////////////////
	// sv
	*/

	0
};

/*//////////////////////////////////////////////////////////////////////
*/

static	struct
{
	HWND	hd;		/* dialog. */
	HWND	hlCommSel;	/* listbox: comm port select. */
}	s_v;

/*//////////////////////////////////////////////////////////////////////
*/

int unit_sel( HWND hwOwner )
{
	LPDLGTEMPLATE
		pdt;	/* dialog. */
			/* no comm port message. */
	LPCTSTR pszENoComm;
	TMES	me;	/* messages. */
	int	ri;	/* result. */

	if ( LID_JPN == GetUserDefaultLCID() )
	{
		pdt = ( LPDLGTEMPLATE )s_awJpn;
		pszENoComm = s_szENoCommJpn;
		me.pszDlg = s_szUnitDlgJpn;
		me.pszList = s_szUnitListJpn;
	}
	else
	{
		pdt = ( LPDLGTEMPLATE )s_awEnu;
		pszENoComm = s_szENoCommEnu;
		me.pszDlg = s_szUnitDlgEnu;
		me.pszList = s_szUnitListEnu;
	}

	if ( 1 > comm_num() )
	{
		( void )MessageBox(
				hwOwner,
				pszENoComm,
				me.pszDlg,
				MB_OK | MB_ICONINFORMATION
				);

#ifndef	_DEBUG
		return NO_COMM;
#endif
	}

	ri = ( int )DialogBoxIndirectParam(
			GetModuleHandle( NULL ),
			pdt,
			hwOwner,
			cb_dlg,
			( LPARAM )&me
			);

	return ri;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	_inline LPCTSTR s_dup( LPCTSTR psz )
{
	LPTSTR	psz1;
	size_t	cch;

	cch = 1 + _tcslen( psz );
	psz1 = LocalAlloc( LPTR, sizeof ( *psz ) * cch );
	if ( NULL == psz )
	{
		return NULL;
	}

	( void )_tcscpy_s( psz1, cch, psz );

	return psz1;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	_inline void e_core( HWND hwOwner )
{
	( void )MessageBox(
			hwOwner,
			s_szENoMemEnu,
			s_szDlgEnu,
			MB_OK | MB_ICONINFORMATION
			);
}

/*//////////////////////////////////////////////////////////////////////
*/

int comm_sel( HWND hwOwner, LPCTSTR pszDlg, LPCTSTR pszList )
{
	LPDLGTEMPLATE
		pdt;	/* dialog. */
			/* no comm port dialog. */
	LPCTSTR pszEDlg;
			/* no comm port message. */
	LPCTSTR pszENoComm;
	TMES	me;	/* messages. */
	int	ri;	/* result. */

	if ( LID_JPN == GetUserDefaultLCID() )
	{
		pdt = ( LPDLGTEMPLATE )s_awJpn;
		pszEDlg = s_szDlgJpn;
		pszENoComm = s_szENoCommJpn;
		if ( NULL == pszDlg )
		{
			me.pszDlg = s_szDlgJpn;
		}
		if ( NULL == pszList )
		{
			me.pszList = s_szListJpn;
		}
	}
	else
	{
		pdt = ( LPDLGTEMPLATE )s_awEnu;
		pszEDlg = s_szDlgEnu;
		pszENoComm = s_szENoCommEnu;
		if ( NULL == pszDlg )
		{
			me.pszDlg = s_szDlgEnu;
		}
		if ( NULL == pszList )
		{
			me.pszList = s_szListEnu;
		}
	}

	if ( 1 > comm_num() )
	{
		( void )MessageBox(
				hwOwner,
				pszENoComm,
				pszEDlg,
				MB_OK | MB_ICONINFORMATION
				);

#ifndef	_DEBUG
		return NO_COMM;
#endif
	}

	if ( NULL != pszDlg )
	{
		me.pszDlg = s_dup( pszDlg );
		if ( NULL == me.pszDlg )
		{
			e_core( hwOwner );

			return -2;
		}
	}

	if ( NULL != pszList )
	{
		me.pszList = s_dup( pszList );
		if ( NULL == me.pszList )
		{
			e_core( hwOwner );

			return -3;
		}
	}

	ri = ( int )DialogBoxIndirectParam(
			GetModuleHandle( NULL ),
			pdt,
			hwOwner,
			cb_dlg,
			( LPARAM )&me
			);

	if ( NULL != pszList )
	{
		( void )LocalFree( ( HLOCAL )me.pszList );
	}

	if ( NULL != pszDlg )
	{
		( void )LocalFree( ( HLOCAL )me.pszDlg );
	}

	return ri;
}

/*//////////////////////////////////////////////////////////////////////
*/

static	BOOL on_init( HWND hd, LPMES pme );
static	BOOL on_cmnd( HWND hd, WPARAM wP );
static	DWORD lb_init( void );
static	int comm_no( void );
static	BOOL dev_ena( HDEVINFO hvi, SP_DEVINFO_DATA* pdid );

/*//////////////////////////////////////////////////////////////////////
*/

static	INT_PTR CALLBACK cb_dlg( HWND hd, UINT uM, WPARAM wP, LPARAM lP )
{
	( void )lP;

	switch ( uM )
	{
	default:
		return FALSE;		/* message not handled. */

	case WM_COMMAND:
		return on_cmnd( hd, wP );

	case WM_DEVICECHANGE:
		( void )lb_init();
		break;

	case WM_INITDIALOG:
		return on_init( hd, ( LPMES )lP );
	}

	return TRUE;			/* message handled. */
}

/*//////////////////////////////////////////////////////////////////////
*/

static	BOOL on_init( HWND hd, LPMES pme )
{
	assert( NULL != hd );
	assert( NULL != pme );

	s_v.hd = hd;
	( void )SetWindowText( hd, pme->pszDlg );
	( void )SetDlgItemText(
			hd,
			IDC_STAT_COMM_SEL,
			pme->pszList
			);
	s_v.hlCommSel = GetDlgItem( hd, IDC_LIST_COMM_SEL );
	( void )lb_init();

	return TRUE;			/* set default focus. */
}

/*//////////////////////////////////////////////////////////////////////
*/

static	BOOL on_cmnd( HWND hd, WPARAM wP )
{
	switch ( wP )
	{
	default:
		return FALSE;		/* message not handled. */

	case MAKELONG( IDCANCEL, BN_CLICKED ):
		( void )EndDialog( hd, NO_COMM );
		break;

	case MAKELONG( IDOK, BN_CLICKED ):
	case MAKELONG( IDC_LIST_COMM_SEL, LBN_DBLCLK ):
		( void )EndDialog( hd, comm_no() );
		break;
	}

	return TRUE;			/* message handled. */
}

/*//////////////////////////////////////////////////////////////////////
*/

static	DWORD lb_init( void )
{
	HDEVINFO
		hvi;	/* device information set. */
	SP_DEVINFO_DATA
		did;	/* device information set data. */
	DWORD	dT;	/* data type */
			/* ERROR_INSUFFICIENT_BUFFER */
			/* ȂȂ΂łłB*/
	TCHAR	sz[ 1 + 4095 ];
	DWORD	nV;	/* # of comm ports found. */
	UINT	ii;	/* device instance #. */

#ifdef	_DEBUG	/*[*/
{
static	BOOL s_fNot1st	= FALSE;

	/*
	// bZ[W\ɂłB
	*/

	if ( NULL == s_v.hlCommSel )
	{
		if ( s_fNot1st )
		{
			return 0;
		}

		s_fNot1st = TRUE;

		return 0;
	}
}
#endif	/*]*/

	( void )SendMessage( s_v.hlCommSel, LB_RESETCONTENT, 0, 0 );

	/*
	// GUID_DEVCLASS_PORTS̃foCX񋓂܂B
	*/

	nV = 0;				/* foCX͂ȂƉ肵܂B*/

	/*
	// ʐM|[gfoCXZbg擾܂B
	*/

	hvi = SetupDiGetClassDevs(
			&GUID_DEVCLASS_PORTS,
			0,
			0,
			DIGCF_PRESENT
			);
	if ( NULL == hvi )
	{
		/*
		// ʐM|[gfoCX܂B
		*/

		return 0;
	}

	/*
	// ʐM|[gfoCX񋓂܂B
	*/

	did.cbSize = sizeof ( did );
	for ( ii = 0; SetupDiEnumDeviceInfo( hvi, ii, &did ); ii++ )
	{
		if ( ! SetupDiGetDeviceRegistryProperty(
				hvi,
				&did,
				SPDRP_FRIENDLYNAME,
				&dT,
				( LPBYTE )sz,
				sizeof ( sz ),
				NULL	/* required bytes  */
				) )
		{
			assert( ERROR_INSUFFICIENT_BUFFER != GetLastError() );

			continue;
		}

		/*
		// 擾ꂽ͕^łH
		*/

		if ( REG_SZ != dT )
		{
			/*
			// ^ł͂܂B
			// ʐM|[gł͂ȂƔf܂B
			// EEE
			*/

			continue;
		}

		/*
		// ʐM|[gł傤H
		//	"ʐM|[g (COM1)"
		//	"USB Serial Port (COM3)"
		//	Ɋ܂܂"COM"T܂B
		// TODO
		//	"ECP v^ |[g (LPT1)"
		//	Ȃǂ"COM"܂܂ĂAEgłB
		*/

		if ( NULL == _tcsstr( sz, s_szComm ) )
		{
			/*
			// Ⴂ܂B
			// EEE
			*/

			continue;
		}

		/*
		// ܂B
		// ĂL܂B
		*/

		if ( ! dev_ena( hvi, &did ) )
		{
			/*
			// G[܂B
			// EEE
			*/

			continue;
		}

		/*
		// add item.
		*/

		( void )SendMessage(
				s_v.hlCommSel,
				LB_ADDSTRING,
				0,
				( LPARAM )sz
				);

		nV++;
	}

	/*
	// foCXZbgj܂B
	*/

	( void )SetupDiDestroyDeviceInfoList( hvi );

	if ( nV )
	{
		( void )SendMessage(
				s_v.hlCommSel,
				LB_SETCURSEL,
				0,
				0
				);
	}

	return nV;
}

/*//////////////////////////////////////////////////////////////////////
*/

#define	CCH_MAX		1023

static	int comm_no( void )
/*
ret	IĂʐM|[g̃|[gԍԂ܂B
*/
{
			/* description. */
	TCHAR	sz[ 1 + CCH_MAX ];
	LPCTSTR	psz;	/* start of "COM...". */
	LRESULT	rl;	/* result. */
	DWORD	cch;	/* */

	rl = SendMessage( s_v.hlCommSel, LB_GETCURSEL, 0, 0 );
	if ( LB_ERR == rl )
	{
		return NO_COMM;
	}

	cch = ( DWORD )SendMessage(
			s_v.hlCommSel,
			LB_GETTEXTLEN,
			( WPARAM )rl,
			0
			);

	if ( CCH_MAX < cch )
	{
		return NO_COMM;
	}

	( void )SendMessage(
			s_v.hlCommSel,
			LB_GETTEXT,
			( WPARAM )rl,
			( LPARAM )sz
			);

	psz = _tcsstr( sz, s_szComm );
	if ( NULL == psz )
	{
		return NO_COMM;
	}

	return ( int )_tcstoul( 3 + psz, NULL, 10 );
}

/*//////////////////////////////////////////////////////////////////////
*/

int comm_num( void )
/*
ret	VXeɑ݂ʐM|[gԂ܂B
*/
{
	HDEVINFO
		hvi;	/* device information set. */
	SP_DEVINFO_DATA
		did;	/* device information set data. */
	DWORD	dT;	/* data type. */
			/* ERROR_INSUFFICIENT_BUFFER */
			/* ȂȂ΂łłB*/
	TCHAR	sz[ 1 + 4095 ];
	int	nV;	/* # of comm ports found. */
	UINT	ii;	/* device instance #. */

	/*
	// GUID_DEVCLASS_PORTS̃foCX񋓂܂B
	*/

	nV = 0;				/* foCX͂ȂƉ肵܂B*/

	/*
	// foCXZbg擾܂B
	*/

	hvi = SetupDiGetClassDevs(
			&GUID_DEVCLASS_PORTS,
			0,
			0,
			DIGCF_PRESENT
			);
	if ( NULL == hvi )
	{
		/*
		// ʐM|[gfoCX܂B
		*/

		return 0;
	}

	/*
	// ʐM|[gfoCX񋓂܂B
	*/

	did.cbSize = sizeof ( did );
	for ( ii = 0; SetupDiEnumDeviceInfo( hvi, ii, &did ); ii++ )
	{
		if ( ! SetupDiGetDeviceRegistryProperty(
				hvi,
				&did,
				SPDRP_FRIENDLYNAME,
				&dT,
				( LPBYTE )sz,
				sizeof ( sz ),
				NULL	/* required bytes  */
				) )
		{
			assert( ERROR_INSUFFICIENT_BUFFER != GetLastError() );

			continue;
		}

		/*
		// 擾ꂽ͕^łH
		*/

		if ( REG_SZ != dT )
		{
			/*
			// ^ł͂܂B
			// ʐM|[gł͂ȂƔf܂B
			// EEE
			*/

			continue;
		}

		/*
		// ʐM|[gł傤H
		//	"ʐM|[g (COM1)"
		//	"USB Serial Port (COM3)"
		//	Ɋ܂܂"COM"T܂B
		// TODO
		//	"ECP v^ |[g (LPT1)"
		//	Ȃǂ"COM"܂܂ĂAEgłB
		*/

		if ( NULL == _tcsstr( sz, s_szComm ) )
		{
			/*
			// Ⴂ܂B
			// EEE
			*/

			continue;
		}

		/*
		// ܂B
		// ĂL܂B
		*/

		if ( ! dev_ena( hvi, &did ) )
		{
			/*
			// G[܂B
			// EEE
			*/

			continue;
		}

		/*
		// found.
		*/

		nV++;
	}

	/*
	// foCXZbgj܂B
	*/

	( void )SetupDiDestroyDeviceInfoList( hvi );

	return nV;
}

/*//////////////////////////////////////////////////////////////////////
*/

BOOL comm_enum( DWORD iInst, LPDWORD piComm )
{
	HDEVINFO
		hvi;	/* device information set. */
	SP_DEVINFO_DATA
		did;	/* device information set data. */
	DWORD	dT;	/* data type. */
			/* ERROR_INSUFFICIENT_BUFFER */
			/* ȂȂ΂łłB*/
	TCHAR	sz[ 1 + 4095 ];
	LPCTSTR	psz;	/* COM??? ̐擪 */
	BOOL	rf;	/* FALSE: ܂łB*/
	UINT	ii;	/* device instance #. */

	/*
	// GUID_DEVCLASS_PORTS̃foCX񋓂܂B
	*/

	rf = FALSE;			/* ʐM|[g͂ȂƉ肵܂B*/

	/*
	// ʐM|[gfoCXZbg擾܂B
	*/

	hvi = SetupDiGetClassDevs(
			&GUID_DEVCLASS_PORTS,
			0,
			0,
			DIGCF_PRESENT
			);
	if ( NULL == hvi )
	{
		/*
		// ʐM|[gfoCX܂B
		*/

		return FALSE;
	}

	/*
	// ʐM|[gfoCX񋓂܂B
	*/

	did.cbSize = sizeof ( did );
	for ( ii = 0; SetupDiEnumDeviceInfo( hvi, ii, &did ); ii++ )
	{
		if ( ! SetupDiGetDeviceRegistryProperty(
				hvi,
				&did,
				SPDRP_FRIENDLYNAME,
				&dT,
				( LPBYTE )sz,
				sizeof ( sz ),
				NULL	/* required bytes  */
				) )
		{
			assert( ERROR_INSUFFICIENT_BUFFER != GetLastError() );

			continue;
		}

		/*
		// 擾ꂽ͕^łH
		*/

		if ( REG_SZ != dT )
		{
			/*
			// ^ł͂܂B
			// ʐM|[gł͂ȂƔf܂B
			// EEE
			*/

			continue;
		}

		/*
		// ʐM|[gł傤H
		//	"ʐM|[g (COM1)"
		//	"USB Serial Port (COM3)"
		//	Ɋ܂܂"COM"T܂B
		// TODO
		//	"ECP v^ |[g (LPT1)"
		//	Ȃǂ"COM"܂܂ĂAEgłB
		*/

		psz = _tcsstr( sz, s_szComm );
		if ( NULL == psz )
		{
			/*
			// Ⴂ܂B
			// EEE
			*/

			continue;
		}

		/*
		// ]݂̃foCXCX^Xԍł傤H
		*/

		if ( iInst )
		{
			/*
			// Ⴂ܂B
			// EEE
			*/

			iInst--;

			continue;
		}

		/*
		// ܂B
		// ĂL܂B
		*/

		if ( ! dev_ena( hvi, &did ) )
		{
			/*
			// G[܂B
			// EEE
			*/

			continue;
		}

		/*
		// found.
		*/

		rf = TRUE;

		/*
		// ʐM|[gԍ͕KvłH
		*/

		if ( NULL == piComm )
		{
			/*
			// svȂ悤ł̂
			// I܂B
			*/

			break;
		}

		/*
		// ʐM|[gԍi[܂B
		*/

		*piComm = _tcstoul( 3 + psz, NULL, 10 );

		break;
	}

	/*
	// foCXZbgj܂B
	*/

	( void )SetupDiDestroyDeviceInfoList( hvi );

	return rf;
}

/*//////////////////////////////////////////////////////////////////////
*/

BOOL comm_enum_x( DWORD iInst, LPDWORD piComm, LPTSTR pszComm, DWORD cchComm )
{
	HDEVINFO
		hvi;	/* device information set. */
	SP_DEVINFO_DATA
		did;	/* device information set data. */
	DWORD	dT;	/* data type. */
			/* ERROR_INSUFFICIENT_BUFFER */
			/* ȂȂ΂łłB*/
	TCHAR	sz[ 1 + 4095 ];
	LPCTSTR	psz;	/* COM??? ̐擪 */
	BOOL	rf;	/* FALSE: ܂łB*/
	UINT	ii;	/* device instance #. */

	/*
	// GUID_DEVCLASS_PORTS̃foCX񋓂܂B
	*/

	rf = FALSE;			/* ʐM|[g͂ȂƉ肵܂B*/

	/*
	// ʐM|[gfoCXZbg擾܂B
	*/

	hvi = SetupDiGetClassDevs(
			&GUID_DEVCLASS_PORTS,
			0,
			0,
			DIGCF_PRESENT
			);
	if ( NULL == hvi )
	{
		/*
		// ʐM|[gfoCX܂B
		*/

		return FALSE;
	}

	/*
	// ʐM|[gfoCX񋓂܂B
	*/

	did.cbSize = sizeof ( did );
	for ( ii = 0; SetupDiEnumDeviceInfo( hvi, ii, &did ); ii++ )
	{
		if ( ! SetupDiGetDeviceRegistryProperty(
				hvi,
				&did,
				SPDRP_FRIENDLYNAME,
				&dT,
				( LPBYTE )sz,
				sizeof ( sz ),
				NULL	/* required bytes  */
				) )
		{
			assert( ERROR_INSUFFICIENT_BUFFER != GetLastError() );

			continue;
		}

		/*
		// 擾ꂽ͕^łH
		*/

		if ( REG_SZ != dT )
		{
			/*
			// ^ł͂܂B
			// ʐM|[gł͂ȂƔf܂B
			// EEE
			*/

			continue;
		}

		/*
		// ʐM|[gł傤H
		//	"ʐM|[g (COM1)"
		//	"USB Serial Port (COM3)"
		//	Ɋ܂܂"COM"T܂B
		// TODO
		//	"ECP v^ |[g (LPT1)"
		//	Ȃǂ"COM"܂܂ĂAEgłB
		*/

		psz = _tcsstr( sz, s_szComm );
		if ( NULL == psz )
		{
			/*
			// Ⴂ܂B
			// EEE
			*/

			continue;
		}

		/*
		// ]݂̃foCXCX^Xԍł傤H
		*/

		if ( iInst )
		{
			/*
			// Ⴂ܂B
			// EEE
			*/

			iInst--;

			continue;
		}

		/*
		// ܂B
		// ĂL܂B
		*/

		if ( ! dev_ena( hvi, &did ) )
		{
			/*
			// G[܂B
			// EEE
			*/

			continue;
		}

		/*
		// found.
		*/

		rf = TRUE;

		/*
		// ʐM|[gԍ͕KvłH
		*/

		if ( NULL != piComm )
		{
			/*
			// ʐM|[gԍi[܂B
			*/

			*piComm = _tcstoul( 3 + psz, NULL, 10 );
		}

		/*
		// fXNvV͕KvłH
		*/

		if ( NULL != pszComm && cchComm )
		{
			/*
			// fXNvVi[܂B
			*/

			( void )_tcscpy_s( pszComm, cchComm, sz );
		}

		break;
	}

	/*
	// foCXZbgj܂B
	*/

	( void )SetupDiDestroyDeviceInfoList( hvi );

	return rf;
}

#if	BFL_ENABLE_IF_DISABLED	/*[*/

/*//////////////////////////////////////////////////////////////////////
foCXĂL܂B
*/

static	BOOL dev_ena( HDEVINFO hvi, SP_DEVINFO_DATA* pdid )
{
	DWORD	st;	/* device status. */
	DWORD	np;	/* problem number. */
	SP_PROPCHANGE_PARAMS
		pcp;	/* to enable device. */
	CONFIGRET
		cr;	/* result. */

	/*
	// foCX̏Ԃ擾܂B
	*/

	cr = CM_Get_DevNode_Status( &st, &np, pdid->DevInst, 0 );
	if ( CR_SUCCESS != cr )
	{
		/*
		// 擾Ɏs܂B
		*/

		return FALSE;
	}

	/*
	// LłH
	*/

	if ( DN_STARTED & st )
	{
		/*
		// LłB
		// ̃foCX͎gpł܂B
		*/

		return TRUE;
	}

	/*
	// Ă܂B
	// L݂܂B
	//	WM_DEVICECHANGE܂B
	*/

	/*
	// Lw܂B
	*/

	pcp.ClassInstallHeader.cbSize = sizeof ( pcp.ClassInstallHeader );
	pcp.ClassInstallHeader.InstallFunction = DIF_PROPERTYCHANGE;
	pcp.StateChange = DICS_ENABLE;
	pcp.Scope = DICS_FLAG_CONFIGSPECIFIC;
	pcp.HwProfile = 0;
	if ( ! SetupDiSetClassInstallParams(
			hvi,
			pdid,
			&pcp.ClassInstallHeader,
			sizeof ( pcp )
			) )
	{
		/*
		// Windows̖ɂ͑ΏłȂ߁A
		// G[͉܂B
		*/

		return FALSE;
	}

	/*
	// w󂯕tꂽL𔽉f܂B
	// Windows̖ɂ͑ΏłȂ߁A
	// G[͉܂B
	*/

	pcp.StateChange = DICS_PROPCHANGE;

	return SetupDiCallClassInstaller(
			DIF_PROPERTYCHANGE,
			hvi,
			pdid
			);
}

#else	/*][*/

/*//////////////////////////////////////////////////////////////////////
foCXĂĂ܂B
*/

static	BOOL dev_ena( HDEVINFO hvi, SP_DEVINFO_DATA* pdid )
{
	DWORD	st;	/* device status. */
	DWORD	np;	/* problem number. */
	CONFIGRET
		cr;	/* result. */

	( void )hvi;

	/*
	// foCX̏Ԃ擾܂B
	*/

	cr = CM_Get_DevNode_Status( &st, &np, pdid->DevInst, 0 );
	if ( CR_SUCCESS != cr )
	{
		/*
		// 擾Ɏs܂B
		*/

		return FALSE;
	}

	/*
	// LłH
	*/

	if ( DN_STARTED & st )
	{
		/*
		// LłB
		// ̃foCX͎gpł܂B
		*/

		return TRUE;
	}

	/*
	// Ă܂B
	// ̃foCX͎gpł܂B
	*/

	return FALSE;
}

#endif	/*]*/
