/*	xbee.h

	Definitions for XBee.

	Copyright (C) CPI Technologies, Inc.
*/

#ifndef	XBEE_H	/*[*/
#define	XBEE_H	1

#ifdef	__cplusplus
extern	"C"
{
#endif

/*//////////////////////////////////////////////////////////////////////
*/

#ifndef	XB_CB_MAX_FRAME	/*[*/

	/*
	// APIt[Ŝ̍őoCg
	// ˑł
	*/
#define	XB_CB_MAX_FRAME		64

#endif	/*]*/

/*======================================================================
*/

/*
// limit.
*/

#define	XB_CCH_MAX_NI		20	/* lbg[NID */

#define	XB_CCH_DELIM		1	/* f~^ */
#define	XB_CB_BYTES		2	/* g̃oCg */
#define	XB_CB_HEAD		( XB_CCH_DELIM + XB_CB_BYTES )
#define	XB_CB_TYPE		1	/* t[^Cv */
#define	XB_CB_ID		1	/* t[ID */
#define	XB_CB_COMMAND		2	/* R}h */
#define	XB_CB_STATUS		1	/* Xe[^X */
#define	XB_CB_SUM		1	/* `FbNT */
#define	XB_CB_CHECKSUM		1	/* `FbNT */

/*======================================================================
*/

/*
// device type.
*/

#define	XB_DT_COORDINATOR	0	/* R[fBl[^ */
#define	XB_DT_COORD		0	/* R[fBl[^ */
#define	XB_DT_ROUTER		1	/* [^ */
#define	XB_DT_END_DEVICE	2	/* GhEfoCX */
#define	XB_DT_DEVICE		2	/* GhEfoCX */

/*
// modem status.
*/

#define	XB_MST_HW_RESET			0x00	/* n[hEFAZbg */
#define	XB_MST_WDT_RESET		0x01	/* WDTZbg */
						/* lbg[N֐ڑ */
						/* ([^ƃGh */
#define	XB_MST_JOINED_NETWORK		0x02	/* foCX) */
#define	XB_MST_DISASSOCIATED		0x03	/* ڑ */
#define	XB_MST__04			0x04
#define	XB_MST__05			0x05
						/* R[fBl[^ */
#define	XB_MST_COORD_STARTED		0x06	/* Jn */
						/* lbg[NE */
						/* ZLeBE */
#define	XB_MST_SECURITY_KEY_UPD		0x07	/* L[XV */
#define	XB_MST__08			0x08
#define	XB_MST__09			0x09
#define	XB_MST__0a			0x0a
#define	XB_MST__0b			0x0b
#define	XB_MST__0c			0x0c
						/* d𒴉 */
#define	XB_MST_VOLT_LIMIT_EXCEEDED	0x0d	/* (PRO S2B̂) */
#define	XB_MST__0e			0x0e
#define	XB_MST__0f			0x0f
#define	XB_MST__10			0x10
						/* ڑɃf */
#define	XB_MST_CONFIG_CHANGED		0x11	/* \ύXꂽ */
#define	XB_MST_STACK_ERROR		0x80	/* ȏX^bNG[ */

/*======================================================================
*/

/*
// API frame
// character constant.
*/

#define	XB_CH_DELIM		0x7e	/* f~^ */
#define	XB_CH_ESCAPE		0x7d	/* GXP[v */
#define	XB_CH_XON		0x11	/* XON */
#define	XB_CH_XOFF		0x13	/* XOFF */
#define	XB_XOR_ESCAPE		0x20	/* XOR܂ */

/*
// API frame
// frame type.
*/

#define	XB_FT_TX_AT		0x08	/* ATR}hv */
					/* ATR}hv */
#define	XB_FT_TX_AT_Q		0x09	/* L[p^ */
#define	XB_FT_TX_ZB		0x10	/* ZigBeeMv */
					/* AhbVO */
#define	XB_FT_TX_ZB_EX		0x11	/* ZigBeeR}ht[ */
#define	XB_FT_TX_RAT		0x17	/* uATR}hv */
#define	XB_FT_TX_SRC		0x21	/* M[g쐬 */
					/* ATR}h */
#define	XB_FT_RX_AT		( 0x80 | XB_FT_TX_AT )
#define	XB_FT_RX_MST		0x8a	/* fXe[^X */
#define	XB_FT_RX_ZB_ST		0x8b	/* ZigBeeMXe[^X */
					/* ZigBeeMpPbg */
#define	XB_FT_RX_ZB		( 0x80 | XB_FT_TX_ZB )
					/* ZigBeeRxCWP[^ */
#define	XB_FT_RX_ZB_EX		( 0x80 | XB_FT_TX_ZB_EX )
					/* ZigBee I/Of[^Tv */
#define	XB_FT_RX_ZB_IO		0x92	/* RxCWP[^ */
					/* XBeeZTǂݏo */
#define	XB_FT_RX_XB_SR		0x94	/* CWP[^ */
#define	XB_FT_RX_NODE		0x95	/* m[hʃCWP[^ */
					/* uATR}h */
#define	XB_FT_RX_RAT		( 0x80 | XB_FT_TX_RAT )
					/* t@[EFA */
#define	XB_FT_RX_FU_ST		0xa0	/* XVXe[^X */
#define	XB_FT_RX_ROUTE		0xa1	/* [gL^CWP[^ */
#define	XB_FT_RX_RT_REQ		0xa3	/* ΂P[gvCWP[^ */

/*
// ZigBee transmit request.
// remote AT command request.
// option bitmap.
*/

#define	XB_OM_DIS_ACK	( 1 << 0 )	/* ACK */
#define	XB_OM_APPLY_CHG	( 1 << 1 )	/* ύXKp */
					/* APSÍL */
#define	XB_OM_ENA_ENC	( 1 << 5 )	/* iEE=1̂Ƃj */
#define	XB_OM_EXT_TMO	( 1 << 6 )	/* g^CAEggp */

/*
// (remote) AT command response
// command status.
*/

#define	XB_AT_OK			0	/* OK */
#define	XB_AT_ERR			1	/* G[ */
#define	XB_AT_INV_CMD			2	/* ȃR}h */
#define	XB_AT_INV_PAR			3	/* ȃp[^ */
						/* TxG[ */
						/* ܂ */
#define	XB_AT_TX_FAIL			4	/* uR}hMs */

/*
// ZigBee transmit status.
// delivery status.
*/

#define	XB_DV_SUCCESS							0x00
#define	XB_DV_MAC_ACK_FAILURE						0x01
#define	XB_DV_CCA_FAILURE						0x02
#define	XB_DV_INVALID_DESTINATION_ENDPOINT				0x15
#define	XB_DV_NETWORK_ACK_FAILURE					0x21
#define	XB_DV_NOT_JOINED_TO_NETWORK					0x22
#define	XB_DV_SELF_ADDRESSED						0x23
#define	XB_DV_ADDRESS_NOT_FOUND						0x24
#define	XB_DV_ROUTE_NOT_FOUND						0x25
#define	XB_DV_BC_SOURCE_FAILED_TO_HEAR_A_NEIGHBOR_REALY_THE_MESSAGE	0x26
#define	XB_DV_INVALID_BINDING_TABLE_INDEX				0x2b
#define	XB_DV_RESOURCE_ERROR_LACK_OF_FREE_BUFFERS_TIMERS_ETC		0x2c
#define	XB_DV_ATTEMPTED_BROADCAST_WITH_APS_TRANSMISSION			0x2d
#define	XB_DV_ATTEMPTED_UNICAST_WITH_APS_TRANSMISSION_BUT_EE_0		0x2e
#define	XB_DV_RESOURCE_ERROR_LACK_OF_FREE_BUFFERS_TIMERS_ETC_32		0x32
#define	XB_DV_DATA_PAYLOAD_TOO_LARGE					0x74
#define	XB_DV_INDIRECT_MESSAGE_UNREQUESTED				0x75

/*
// ZigBee transmit status.
// discovery status.
*/

#define	XB_DC_NO_DISCOVERY_OVERHEAD		0x00
#define	XB_DC_ADDRES_DISCOVERY			0x01
#define	XB_DC_ROUTE_DISCOVERY			0x02
#define	XB_DC_ADDRESS_AND_ROUTE			0x03
#define	XB_DC_EXTENDED_TIMEOUT_DISCOVERY	0x40

/*//////////////////////////////////////////////////////////////////////
*/

/*[*/
#ifdef	_MSC_VER
#pragma	pack( push, 1 )
#endif

typedef	struct	/* wb_ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
}	TXBAFH0;

typedef	struct	/* wb_ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
}	TXBAFH1;

typedef	struct	/* t[ID܂ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
}	TXBAFH;

typedef	struct	/* 0x08 ATR}hvR}h܂ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
			/* R}h */
char		cm[ 2 ];
}	TXBTXATH;

typedef	struct	/* 0x10 ZigBeeMvIvV܂ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
unsigned _int32	DH;	/* MAhX */
unsigned _int32	DL;	/* MAhX */
unsigned _int16	D16;	/* 16rbgMAhX */
unsigned char	bcr;	/* u[hLXg͈ */
			/*	0x01 ACK */
			/*	0x20 APSÍLiEE=1̏ꍇj */
			/*	0x40 ̑MɑM^CAEggp */
unsigned char	opt;	/* IvV */
}	TXBTXZBH;

typedef	struct	/* 0x17 uATR}hvR}h܂ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
unsigned _int32	DH;	/* MAhX */
unsigned _int32	DL;	/* MAhX */
unsigned _int16	D16;	/* 16rbgMAhX */
			/*	0x01 ACK */
			/*	0x02 ύXL */
			/*	0x20 APSÍLiEE=1̏ꍇj */
			/*	0x40 ̑MɑM^CAEggp */
unsigned char	opt;	/* IvV */
			/* R}h */
char		cm[ 2 ];
}	TXBTXRATH;

typedef	struct	/* 0x88 ATR}hXe[^X܂ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
			/* R}h */
char		cm[ 2 ];
			/*	0 OK */
			/*	1 G[ */
			/*	2 ȃR}h */
			/*	3 ȃp^ */
unsigned char	st;	/*	4 TxG[ */
}	TXBRXATH;

typedef	struct	/* 0x88 PATNDR}hNI܂ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
			/* R}h */
char		cm[ 2 ];
			/*	0 OK */
			/*	1 G[ */
			/*	2 ȃR}h */
			/*	3 ȃp^ */
unsigned char	st;	/*	4 TxG[ */
unsigned _int16	my;	/* 16rbglbg[NAhX */
unsigned _int32	sh;	/* ʃVAԍ */
unsigned _int32	sl;	/* ʃVAԍ */
			/* m[hʎq */
char		ni[ 1 + 20 ];
#if	0	/*[ ȉni̒ɂ肸܂B */
unsigned _int16	pa;	/* ẽlbg[NAhX */
			/* foCX^Cv */
			/*	0 coordinator. */
			/*	1 router. */
unsigned char	dt;	/*	2 end device. */
unsigned char	st;	/* Xe[^X */
unsigned _int16	pid;	/* vt@CID */
unsigned _int16	fid;	/* HID */
#endif	/*]*/
}	TXBRXATNDH;

		/* 0x92 ZigBee I/Of[^ETvRxCWP[^ */
typedef	struct	/* AiO`l}XN܂ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned _int32	SH;	/* MAhX */
unsigned _int32	SL;	/* MAhX */
unsigned _int16	S16;	/* 16rbgMAhX */
			/* MIvV */
			/*	0x01 FꂽpPbg */
unsigned char	opt;	/*	0x02 pPbg̓u[hLXg */
			/* Tv */
			/* yC[hɊ܂܂ĂTvZbg */
unsigned char	cs;	/* iɂPɐݒj */
			/* fW^`l}XN */
			/* TvO\ȃfW^ */
unsigned _int16	MD;	/* I/Õrbg}bv */
			/* AiO`l}XN */
			/* TvO\ȃAiO */
unsigned _int16	MA;	/* I/Õrbg}bv */
}	TXBRXIOH;

typedef	struct	/* 0x97 uATR}hXe[^X܂ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
unsigned _int32	DH;	/* MAhX */
unsigned _int32	DL;	/* MAhX */
unsigned _int16	D16;	/* 16rbgMAhX */
			/* R}h */
char		cm[ 2 ];
			/*	0 OK */
			/*	1 G[ */
			/*	2 ȃR}h */
			/*	3 ȃp^ */
unsigned char	st;	/*	4 uR}hMs */
}	TXBRXRATH;

typedef	union	/* APIt[ */
{

unsigned char	ab[ XB_CB_MAX_FRAME ];

char		ach[ XB_CB_MAX_FRAME ];

struct	/* wb_ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
			/*  */
unsigned char	ab[ XB_CB_MAX_FRAME - sizeof ( TXBAFH0 ) ];
}	hd0;

struct	/* t[^Cv܂ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
			/*  */
unsigned char	ab[ XB_CB_MAX_FRAME - sizeof ( TXBAFH1 ) ];
}	hd1;

struct	/* t[ID܂ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
			/*  */
unsigned char	ab[ XB_CB_MAX_FRAME - sizeof ( TXBAFH ) ];
}	hd;

struct	/* 0x08 ATR}hv */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
			/* R}h */
char		cm[ 2 ];
			/* p^A`FbNT */
unsigned char	ds[ XB_CB_MAX_FRAME - sizeof ( TXBTXATH ) ];
}	txat;

struct	/* 0x10 ZigBeeMv */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
unsigned _int32	DH;	/* MAhX */
unsigned _int32	DL;	/* MAhX */
unsigned _int16	D16;	/* 16rbgMAhX */
unsigned char	bcr;	/* u[hLXg͈ */
			/* IvV */
			/*	0x01 ACK */
			/*	0x20 APSÍLiEE=1̏ꍇj */
unsigned char	opt;	/*	0x40 ̑MɑM^CAEggp */
			/* Mf[^A`FbNT */
char		ds[ XB_CB_MAX_FRAME - sizeof ( TXBTXZBH ) ];
}	txzb;

struct	/* 0x17 uATR}hv */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
unsigned _int32	DH;	/* MAhX */
unsigned _int32	DL;	/* MAhX */
unsigned _int16	D16;	/* 16rbgMAhX */
			/*	0x01 ACK */
			/*	0x02 ύXL */
			/*	0x20 APSÍLiEE=1̏ꍇj */
			/*	0x40 ̑MɑM^CAEggp */
unsigned char	opt;	/* IvV */
			/* R}h */
char		cm[ 2 ];
			/* p^A`FbNT */
unsigned char	ds[ XB_CB_MAX_FRAME - sizeof ( TXBTXRATH ) ];
}	txrat;

struct	/* 0x88 ATR}h */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
			/* R}h */
char		cm[ 2 ];
			/*	0 OK */
			/*	1 G[ */
			/*	2 ȃR}h */
			/*	3 ȃp^ */
unsigned char	st;	/*	4 TxG[ */
			/* f[^A`FbNT */
unsigned char	ds[ XB_CB_MAX_FRAME - sizeof ( TXBRXATH ) ];
}	rxat;

struct	/* 0x88 ATNDR}h */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
			/* R}h */
char		cm[ 2 ];
			/*	0 OK */
			/*	1 G[ */
			/*	2 ȃR}h */
			/*	3 ȃp^ */
unsigned char	st;	/*	4 TxG[ */
			/* f[^A`FbNT */
unsigned _int16	my;	/* 16rbglbg[NAhX */
unsigned _int32	sh;	/* ʃVAԍ */
unsigned _int32	sl;	/* ʃVAԍ */
			/* m[hʎq */
char		ni[ 1 + 20 ];
			/* c̃f[^A`FbNT */
unsigned char	ds[ XB_CB_MAX_FRAME - sizeof ( TXBRXATNDH ) ];
}	rxatnd;

struct	/* 0x8a fXe[^X */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	st;	/* Xe[^X */
unsigned char	sum;	/* `FbNT */
}	rxmst;

struct	/* 0x8b ZigBeeMXe[^X */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */

unsigned _int16	S16;	/* M16rbglbg[NAhX */
unsigned char	nRetry;	/* MĎs */
			/* zXe[^X */
			/*	0x00  */
			/*	0x01 MAC ACKs */
			/*	0x02 CCAs */
			/*	0x15 sȑMGh|Cg */
			/*	0x21 lbg[NACKs */
			/*	0x22 lbg[Nɕsڑ */
			/*	0x23 ȃAhX */
			/*	0x24 AhX */
			/*	0x25 [g */
			/*	0x26 u[hLXg̑Mאڂ */
			/*	     bZ[W]̎MɎs */
			/*	0x2b ȃoCfBOECfbNX */
			/*	     e[u */
			/*	0x2c gp\ȃobt@A^C} */
			/*	     \[XEG[ */
			/*	0x2d APSMɂu[hLXg̎s */
			/*	0x2e APSMɂ郆jLXg̎s */
			/*	     EE=0 */
			/*	0x32 gp\ȃobt@A^C} */
			/*	     \[XEG[ */
			/*	0x74 f[^yC[h */
			/*	0x75 v̊ԐڃbZ[W */
unsigned char	stDelivery;
			/* TXe[^X */
			/*	0x00 I[o[wbh */
			/*	0x01 AhX */
			/*	0x02 [g */
			/*	0x03 AhXƃ[g */
			/*	0x40 g^CAEg */
unsigned char	stDiscovery;
unsigned char	bSum;	/* `FbNT */
}	rxzbst;

struct	/* 0x90 ZigBeeMpPbg */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned _int32	SH;	/* MAhX */
unsigned _int32	SL;	/* MAhX */
unsigned _int16	S16;	/* 16rbgMAhX */
			/* MIvV */
			/*	0x01 FꂽpPbg */
			/*	0x02 u[hLXgpPbg */
			/*	0x20 APSňÍꂽpPbg */
unsigned char	opt;	/*	0x40 GhfoCX瑗ꂽpPbg */
			/* Mf[^A`FbNT */
char		ds[ XB_CB_MAX_FRAME - sizeof ( TXBTXZBH ) ];
}	rxzb;

struct	/* 0x92 ZigBee I/Of[^ETvRxCWP[^ */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned _int32	SH;	/* MAhX */
unsigned _int32	SL;	/* MAhX */
unsigned _int16	S16;	/* 16rbgMAhX */
			/* MIvV */
			/*	0x01 FꂽpPbg */
unsigned char	opt;	/*	0x02 pPbg̓u[hLXg */
			/* Tv */
			/* yC[hɊ܂܂ĂTvZbg */
unsigned char	cs;	/* iɂPɐݒj */
			/* fW^`l}XN */
			/* TvO\ȃfW^ */
unsigned _int16	MD;	/* I/Õrbg}bv */
			/* AiO`l}XN */
			/* TvO\ȃAiO */
unsigned char	ma;	/* I/Õrbg}bv */
			/* f[^A`FbNT */
unsigned char	ds[ XB_CB_MAX_FRAME - sizeof ( TXBRXIOH ) ];
}	rxio;

struct	/* 0x97 uATR}h */
{
unsigned char	chD;	/* f~^ */
unsigned _int16	CB;	/* big-endian: ƃ`FbNT̊Ԃ̃oCg */
unsigned char	ft;	/* t[^Cv */
unsigned char	fid;	/* t[ID */
unsigned _int32	SH;	/* MAhX */
unsigned _int32	SL;	/* MAhX */
unsigned _int16	S16;	/* 16rbgMAhX */
			/* R}h */
char		cm[ 2 ];
			/*	0 OK */
			/*	1 G[ */
			/*	2 ȃR}h */
			/*	3 ȃp^ */
unsigned char	st;	/*	4 uR}hMs */
			/* f[^A`FbNT */
unsigned char	ds[ XB_CB_MAX_FRAME - sizeof ( TXBRXRATH ) ];
}	rxrat;

}	TXBAF;

typedef	TXBAF FAR*	LPXBAF;

#pragma	pack( pop )
/*]*/

#ifdef	__cplusplus
}
#endif

#endif	/*]*/
