//=======================================================================================================
//
// CPI-ZD132/232/332TvvO
//
// Copyright (C) CPI Technologies, Inc.
//
//=======================================================================================================
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;

using System.IO.Ports;
using System.IO;
using System.Threading;

using Win32API;

namespace ns_zdx32
{
    public partial class Form1 : Form
    {
        //-----------------------------------------------------------------------------------------------
        // constructor
        //-----------------------------------------------------------------------------------------------
        public Form1()
        {
            InitializeComponent();
        }
        //-----------------------------------------------------------------------------------------------
        // Load
        //-----------------------------------------------------------------------------------------------
        private void Form1_Load(object sender, EventArgs e)
        {
            // COM|[gComboboxɒǉ
#if false   //[
            string[] portnum = SerialPort.GetPortNames();
#else   //][
            string[] portnum = SPN.GetFriendlyPortNames();
#endif  //]
            comboBoxComSelect.Items.AddRange(portnum);
        }
        //-----------------------------------------------------------------------------------------------
        // FormClosed
        //-----------------------------------------------------------------------------------------------
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            // COM|[gCloseiMcloseƗO܂j
            if (serialPort1.IsOpen) serialPort1.Close();
        }
        //-----------------------------------------------------------------------------------------------
        // COM|[g{^ clicked
        //-----------------------------------------------------------------------------------------------
        private void buttonComSelect_Click(object sender, EventArgs e)
        {
#if false   //[
            if (comboBoxComSelect.Items.Count > 0) {
                                                // ɊJĂ
                if (serialPort1.IsOpen) serialPort1.Close();
                serialPort1.PortName = (string)comboBoxComSelect.SelectedItem;
                try {
                    serialPort1.Open();
                }
                catch (UnauthorizedAccessException) {
                    MsgOut("VA|[gI[vł܂");
                    this.Close();
                }
            }
#else   //][
            if (comboBoxComSelect.Items.Count > 0) {
                                                // ɊJĂ
                if (serialPort1.IsOpen) serialPort1.Close();

                string sc = SPN.ConvertToPortName(
                        (string)comboBoxComSelect.SelectedItem
                        );
                if (null == sc) {
                    return;
                }

                serialPort1.PortName = sc;
                try {
                    serialPort1.Open();
                }
                catch (UnauthorizedAccessException) {
                    MsgOut("VA|[gI[vł܂");
                    this.Close();
                }
            }
#endif  //]

            xbl = new XBlib(serialPort1);

            groupBoxUnitStatus.Enabled = true;  // CPI-ZDR[fBl[^mFE񋓁Ew
            groupBoxInputCmd.Enabled = true;    // ̓R}h
                                                // tB^ݒR}h
            groupBoxFiltersetCmd.Enabled = true;
            groupBoxPortprm.Enabled = true;     // |[gĎp[^ݒR}h
            groupBoxPortsts.Enabled = true;     // |[gĎԎ擾
            groupBoxOutputCmd.Enabled = true;   // o̓R}h
            // WDT
            groupBoxWdtToutsetCmd.Enabled = true;
                                                // JE^ZbgR}h
            groupBoxWdtCntresetCmd.Enabled = true;
                                                // ^CAEgo͒lݒR}h
            groupBoxWdtToutdatCmd.Enabled = true;
            groupBoxWdtstsCmd.Enabled = true;   // Xe[^X擾R}h
                                                // Xe[^XNAR}h
            groupBoxWdtstsclrCmd.Enabled = true;
                                                // o͒lNAR}h
            groupBoxWdtToutclrCmd.Enabled = true;
            groupBoxLasterrCmd.Enabled = true;  // ŌɔG[R[h擾R}h
            groupBoxFverCmd.Enabled = true;     // t@[EFAo[W擾R}h
                                                // jbgZNgXCb`ݒl擾R}h
            groupBoxUnitselswCmd.Enabled = true;
            groupBoxUnittypeCmd.Enabled = true; // jbg^Cv擾R}h
            groupBoxUnitnameCmd.Enabled = true; // jbg擾R}h
            groupBoxAtdb.Enabled = true;        // dEx擾R}h
            groupBoxNop.Enabled = true;         // NOPR}h
        }
        //-----------------------------------------------------------------------------------------------
        // ListBoxւ̃bZ[W\
        //-----------------------------------------------------------------------------------------------
        private void ListDisp(string s)
        {
            if (null == s) {
                s = "ʐMG[܂";
            }
            listBox1.Items.Add(s);
            listBox1.SetSelected(listBox1.Items.Count - 1, true);
        }
        //-----------------------------------------------------------------------------------------------
        // G[bZ[W̕\
        //-----------------------------------------------------------------------------------------------
        private void MsgOut(string s)
        {
            MessageBox.Show(s, "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
        //===============================================================================================
        // CPI-ZDjbgmFE񋓁Ew Go{^ clicked
        //    ̏̂ATR}h[hœ
        //    ȒlԂȂꍇ͑҂Ԃ𒷂߂ɂĂ
        //===============================================================================================
        private void button3_exec_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            this.ActiveControl = null;
            button3_exec.Enabled = false;
            string s = "Timeout";
            //--------------------------------
            // 3.1.  R[fBl[^mF
            //--------------------------------
            if (radioButton3_1.Checked == true) {
                s = Zdlib_p3_1();               // 1000=1b҂Ă猋ʂM
            }
            //--------------------------------
            // 3.2 jbg
            //--------------------------------
            else if (radioButton3_2.Checked == true) {
                comboBox3_2a.Items.Clear();
                string[] units = Zdlib_p3_2();
                if (units != null) {
                    foreach (string w in units) {
                        if (w == null) break;
                        comboBox3_2a.Items.Add(w);
                        ListDisp(w);
                    }
                    s = comboBox3_2a.Items.Count + "̃jbg܂";
                    if (comboBox3_2a.Items.Count > 0) comboBox3_2a.Text = comboBox3_2a.Items[0].ToString();
                } else s = "Timeout";
            }
            //--------------------------------
            // 3.2a jbgw
            //--------------------------------
            else {
                string unit = comboBox3_2a.Text;
                if (unit == "") {
                    s = "jbgw肳Ă܂";
                }
                else {
                    if (Zdlib_p3_2a(comboBox3_2a.SelectedIndex)) {
                        s = comboBox3_2a.Text + " jbgw肵܂";
                    }
                }
            }
            // \
            ListDisp(s);
            button3_exec.Enabled = true;
            this.Cursor = Cursors.Default;
        }
        //===============================================================================================
        // ̓R}h Go{^ clicked
        //===============================================================================================
        private void button4_exec_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonInputCmd.Enabled = false;
            textBoxInputCmdVi.Text = "";
            textBoxInputCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string rxd, ip, vi, ec;
            ip = comboBoxInputCmd.Text;         // ip
            rxd = Zdlib_InputCmd(ip);           // R}hMƌʎMi^CAEg1bj
            string[] token = rxd.Split(' ');    // Mf[^g[Nɕ
            // ʂ擾
            vi = "-";
            ec = token[0];                      // ec
            if (ec == "00") {                   // Ȃ
                vi = token[1];                  // vi
            }
            // Rg[ɕ\
            textBoxInputCmdVi.Text = vi;        // vil
            textBoxInputCmdEc.Text = ec;        // G[R[h
            buttonInputCmd.Enabled = true;
        }
        //===============================================================================================
        // tB^ݒR}h Go{^ clicked
        //===============================================================================================
        private void buttonFiltersetCmd_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonFiltersetCmd.Enabled = false;
            textBoxFiltersetCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string fi, rm, ec;
                                                // fi
            fi = comboBoxFiltersetCmd.Text.Substring(0, 1);
            rm = textBoxFiltersetCmdWrite.Text; // rm
                                                // R}hMƌʎMi^CAEg1bj
            ec = Zdlib_FiltersetCmd(fi, rm);
            // Rg[ɕ\
            textBoxFiltersetCmdEc.Text = ec;    // G[R[h
            buttonFiltersetCmd.Enabled = true;
        }
        //===============================================================================================
        // |[gĎp[^ݒR}h Go{^ clicked
        //===============================================================================================
        private void button1_Click_1(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonPortprmCmd.Enabled = false;
            textBoxPortprmCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string ip, md, bm, bd, ec;
            ip = comboBoxPortMonSet.Text;       // ip
                                                // md
            md = comboBoxPortprmCmdMd.Text.Substring(0, 1);
            bm = textBoxPortprmCmdBm.Text;      // bm
            bd = textBoxPortprmCmdBd.Text;      // bd
                                                // R}hMƌʎMi^CAEg1bj
            ec = Zdlib_PortprmCmd(ip, md, bm, bd);
            // Rg[ɕ\
            textBoxPortprmCmdEc.Text = ec;      // G[R[h
            buttonPortprmCmd.Enabled = true;
        }
        //===============================================================================================
        // |[gĎԎ擾 Go{^ clicked
        //===============================================================================================
        private void buttonPortsts_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonPortsts.Enabled = false;
            textBoxPortstsSt.Text = "";
            textBoxPortstsBd.Text = "";
            textBoxPortstsEc.Text = "";
            Application.DoEvents();
            // Ms
            string rxd, ip, st, bd, ec;
            ip = comboBoxPortMonStatGet.Text;   // ip
            rxd = Zdlib_Portsts(ip);      // R}hMƌʎMi^CAEg1bj
            string[] token = rxd.Split(' ');    // Mf[^g[Nɕ
            // ʂ擾
            st = bd = "-";
            ec = token[0];                      // ec
            if (ec == "00") {                   // Ȃ
                st = token[1];                  // st
                bd = token[2];                  // bd
            }
            // Rg[ɕ\
            textBoxPortstsSt.Text = st;
            textBoxPortstsBd.Text = bd;
            textBoxPortstsEc.Text = ec;         // G[R[h
            buttonPortsts.Enabled = true;
        }
        //===============================================================================================
        // o̓R}h Go{^ clicked
        //===============================================================================================
        private void buttonOutputCmd_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonOutputCmd.Enabled = false;
            textBoxOutputCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string ip, bd, ec;
                                                // md
            ip = comboBoxOutputCmdIp.Text.Substring(0, 1);
            bd = textBoxOutputCmdBd.Text;       // bd
            ec = Zdlib_OutputCmd(ip, bd); // R}hMƌʎMi^CAEg1bj
            // Rg[ɕ\
            textBoxOutputCmdEc.Text = ec;       // G[R[h
            buttonOutputCmd.Enabled = true;
        }
        //===============================================================================================
        // WDT^CAEgݒR}h Go{^ clicked
        //===============================================================================================
        private void buttonWdttoutsetCmd_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonWdtToutsetCmd.Enabled = false;
            textBoxWdtToutsetCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string to, ec;
            to = comboBoxWdtToutsetCmd.SelectedIndex.ToString();
            ec = Zdlib_WdtToutsetCmd(to); // R}hMƌʎMi^CAEg1bj
            // Rg[ɕ\
            textBoxWdtToutsetCmdEc.Text = ec;   // G[R[h
            buttonWdtToutsetCmd.Enabled = true;
        }
        //===============================================================================================
        // WDTJE^ZbgR}h Go{^ clicked
        //===============================================================================================
        private void buttonWdtCntresetCmd_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonWdtCntresetCmd.Enabled = false;
            textBoxWdtCntresetCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string ec;
            ec = Zdlib_WdtCntresetCmd(1000);    // R}hMƌʎMi^CAEg1bj
            // Rg[ɕ\
            textBoxWdtCntresetCmdEc.Text = ec;  // G[R[h
            buttonWdtCntresetCmd.Enabled = true;
        }
        //===============================================================================================
        // WDT^CAEgo͒lݒR}h Go{^ clicked
        //===============================================================================================
        private void buttonWdtToutdatCmd_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonWdtToutdatCmd.Enabled = false;
            textBoxWdtToutdatCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string ip, bd, ec;
            ip = comboBoxPortWdtOutSet.Text;    // ip
            bd = textBoxWdtToutdatCmdBd.Text;   // bd
                                                // R}hMƌʎMi^CAEg1bj
            ec = Zdlib_WdtToutdatCmd(ip, bd);
            // Rg[ɕ\
            textBoxWdtToutdatCmdEc.Text = ec;   // G[R[h
            buttonWdtToutdatCmd.Enabled = true;
        }
        //===============================================================================================
        // WDTXe[^X擾R}h Go{^ clicked
        //===============================================================================================
        private void buttonWdtstsCmd_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonWdtstsCmd.Enabled = false;
            textBoxWdtstsCmdSt.Text = "";
            textBoxWdtstsCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string rxd, st, ec;
            rxd = Zdlib_WdtstsCmd(1000);        // R}hMƌʎMi^CAEg1bj
            string[] token = rxd.Split(' ');    // Mf[^g[Nɕ
            // ʂ擾
            st = "-";
            ec = token[0];                      // ec
            if (ec == "00") {                   // Ȃ
                st = token[1];                  // vi
            }
            // Rg[ɕ\
            textBoxWdtstsCmdSt.Text = st;       // stl
            textBoxWdtstsCmdEc.Text = ec;       // G[R[h
            buttonWdtstsCmd.Enabled = true;
        }
        //===============================================================================================
        // WDTXe[^XNAR}h Go{^ clicked
        //===============================================================================================
        private void buttonWdtstsclrCmd_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonWdtstsclrCmd.Enabled = false;
            textBoxWdtstsclrCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string ec;
            ec = Zdlib_WdtstsclrCmd(1000);      // R}hMƌʎMi^CAEg1bj
            // Rg[ɕ\
            textBoxWdtstsclrCmdEc.Text = ec;    // G[R[h
            buttonWdtstsclrCmd.Enabled = true;
        }
        //===============================================================================================
        // WDTo͒lNAR}h Go{^ clicked
        //===============================================================================================
        private void buttonWdtToutclrCmd_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonWdtToutclrCmd.Enabled = false;
            textBoxWdtToutclrCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string ec;
            ec = Zdlib_WdtToutclrCmd(1000);     // R}hMƌʎMi^CAEg1bj
            // Rg[ɕ\
            textBoxWdtToutclrCmdEc.Text = ec;   // G[R[h
            buttonWdtToutclrCmd.Enabled = true;
        }
        //===============================================================================================
        // ŌɔG[R[h擾R}h Go{^ clicked
        //===============================================================================================
        private void buttonLasterrCmd_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonLasterrCmd.Enabled = false;
            textBoxLasterrCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string ec;
            ec = Zdlib_LasterrCmd(1000);        // R}hMƌʎMi^CAEg1bj
            // Rg[ɕ\
            textBoxLasterrCmdEc.Text = ec;      // G[R[h
            buttonLasterrCmd.Enabled = true;
        }
        //===============================================================================================
        // t@[EFAo[W擾R}h Go{^ clicked
        //===============================================================================================
        private void buttonFverCmd_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonFverCmd.Enabled = false;
            textBoxFverCmdSv.Text = "";
            textBoxFverCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string rxd, sv, ec;
            rxd = Zdlib_FverCmd(1000);          // R}hMƌʎMi^CAEg1bj
            string[] token = rxd.Split(' ');    // Mf[^g[Nɕ
            // ʂ擾
            sv = "-";
            ec = token[0];                      // ec
            if (ec == "00") {                   // Ȃ
                sv = token[1];                  // vi
            }
            // Rg[ɕ\
            textBoxFverCmdSv.Text = sv;         // svl
            textBoxFverCmdEc.Text = ec;         // G[R[h
            buttonFverCmd.Enabled = true;
        }
        //===============================================================================================
        // jbgZNgXCb`ݒl擾R}h Go{^ clicked
        //===============================================================================================
        private void buttonUnitselswCmd_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonUnitselswCmd.Enabled = false;
            textBoxUnitselswCmdBs.Text = "";
            textBoxUnitselswCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string rxd, bs, ec;
            rxd = Zdlib_UnitselswCmd(1000);     // R}hMƌʎMi^CAEg1bj
            string[] token = rxd.Split(' ');    // Mf[^g[Nɕ
            // ʂ擾
            bs = "-";
            ec = token[0];                      // ec
            if (ec == "00") {                   // Ȃ
                bs = token[1];                  // vi
            }
            // Rg[ɕ\
            textBoxUnitselswCmdBs.Text = bs;    // bsl
            textBoxUnitselswCmdEc.Text = ec;    // G[R[h
            buttonUnitselswCmd.Enabled = true;
        }
        //===============================================================================================
        // jbg^Cv擾R}h Go{^ clicked
        //===============================================================================================
        private void buttonUnittypeCmd_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonUnittypeCmd.Enabled = false;
            textBoxUnittypeCmdBt.Text = "";
            textBoxUnittypeCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string rxd, bt, ec;
            rxd = Zdlib_UnittypeCmd(1000);      // R}hMƌʎMi^CAEg1bj
            string[] token = rxd.Split(' ');    // Mf[^g[Nɕ
            // ʂ擾
            bt = "-";
            ec = token[0];                      // ec
            if (ec == "00") {                   // Ȃ
                bt = token[1];                  // bt
            }
            // Rg[ɕ\
            textBoxUnittypeCmdBt.Text = bt;     // btl
            textBoxUnittypeCmdEc.Text = ec;     // G[R[h
            buttonUnittypeCmd.Enabled = true;
        }
        //===============================================================================================
        // jbg擾R}h Go{^ clicked
        //===============================================================================================
        private void buttonUnitnameCmd_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonUnitnameCmd.Enabled = false;
            textBoxUnitnameCmdUn.Text = "";
            textBoxUnitnameCmdEc.Text = "";
            Application.DoEvents();
            // Ms
            string rxd, un, ec;
            rxd = Zdlib_UnitnameCmd(1000);      // R}hMƌʎMi^CAEg1bj
            string[] token = rxd.Split(' ');    // Mf[^g[Nɕ
            // ʂ擾
            un = "-";
            ec = token[0];                      // ec
            if (ec == "00") {                   // Ȃ
                un = token[1];                  // vi
            }
            // Rg[ɕ\
            textBoxUnitnameCmdUn.Text = un;     // unl
            textBoxUnitnameCmdEc.Text = ec;     // G[R[h
            buttonUnitnameCmd.Enabled = true;
        }
        //===============================================================================================
        // dEx擾R}h Go{^ clicked
        //===============================================================================================
        private void buttonAtdb_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonAtdb.Enabled = false;
            textBoxAtdbDb.Text = "";
            textBoxAtdbRc.Text = "";
            Application.DoEvents();
            // Ms
            byte dbm = 0;
            string rc = Zdlib_Atdb(ref dbm);    // R}hMƌʎM
            // Rg[ɕ\
                                                // dEx\
            textBoxAtdbDb.Text = "-" + dbm.ToString() + "dBm";
            textBoxAtdbRc.Text = rc;
            buttonAtdb.Enabled = true;
        }
        //===============================================================================================
        // NOPR}h Go{^ clicked
        //===============================================================================================
        private void buttonNop_Click(object sender, EventArgs e)
        {
            // Rg[Ă
            this.ActiveControl = null;
            buttonNop.Enabled = false;
            textBoxNopEc.Text = "";
            Application.DoEvents();
            // Ms
            string ec;
            ec = Zdlib_Nop(1000);               // R}hMƌʎMi^CAEg1bj
            // Rg[ɕ\
            textBoxNopEc.Text = ec;             // G[R[h
            buttonNop.Enabled = true;
        }
        //===============================================================================================
        // \lNA{^ clicked
        //===============================================================================================
        private void buttonClearAll_Click(object sender, EventArgs e)
        {
            textBoxUnittypeCmdBt.Text = "";
            textBoxUnittypeCmdEc.Text = "";
            textBoxUnitnameCmdUn.Text = "";
            textBoxUnitnameCmdEc.Text = "";
            textBoxUnitselswCmdBs.Text = "";
            textBoxUnitselswCmdEc.Text = "";
            textBoxFverCmdSv.Text = "";
            textBoxFverCmdEc.Text = "";
            textBoxAtdbDb.Text = "";
            textBoxAtdbRc.Text = "";
            textBoxNopEc.Text = "";
            textBoxLasterrCmdEc.Text = "";
            comboBoxInputCmd.SelectedIndex = 0;
            textBoxInputCmdVi.Text = "";
            textBoxInputCmdEc.Text = "";
            comboBoxFiltersetCmd.SelectedIndex = 0;
            textBoxFiltersetCmdWrite.Text = "0";
            textBoxFiltersetCmdEc.Text = "";
            comboBoxPortMonSet.SelectedIndex = 0;
            comboBoxPortprmCmdMd.SelectedIndex = 0;
            textBoxPortprmCmdBm.Text = "00";
            textBoxPortprmCmdBd.Text = "00";
            textBoxPortprmCmdEc.Text = "";
            comboBoxPortMonStatGet.SelectedIndex = 0;
            textBoxPortstsSt.Text = "";
            textBoxPortstsBd.Text = "";
            textBoxPortstsEc.Text = "";
            comboBoxOutputCmdIp.SelectedIndex = 0;
            textBoxOutputCmdBd.Text = "00";
            textBoxOutputCmdEc.Text = "";
            comboBoxWdtToutsetCmd.SelectedIndex = 0;
            textBoxWdtToutsetCmdEc.Text = "";
            comboBoxPortWdtOutSet.SelectedIndex = 0;
            textBoxWdtToutdatCmdBd.Text = "00";
            textBoxWdtToutdatCmdEc.Text = "";
            textBoxWdtToutclrCmdEc.Text = "";
            textBoxWdtstsCmdSt.Text = "";
            textBoxWdtstsCmdEc.Text = "";
            textBoxWdtstsclrCmdEc.Text = "";
            textBoxWdtCntresetCmdEc.Text = "";
        }

        //==============================================================
        // ComboBox
        //  ignore pressed keys.
        //==============================================================
        private void ign_kp(object sender, KeyPressEventArgs e)
        {
            e.Handled = true;
        }

        //==============================================================
        // TextBox: decimal.
        //  key pressed.
        //==============================================================
        private void e10_kp(object sender, KeyPressEventArgs e)
        {
            if ('0' <= e.KeyChar && e.KeyChar <= '9') {
                return;
            }
            if (e.KeyChar < ' ') {
                return;
            }
            e.Handled = true;
        }

        //==============================================================
        // TextBox: decimal.
        //  lost focus.
        //==============================================================
        private void e10_lf(TextBox ctrl)
        {
            if (1 > ctrl.Text.Length) {
                ctrl.Text = "0";

                return;
            }

            int bVal;

            bVal = Convert.ToInt32(ctrl.Text);
            if (Convert.ToInt32(ctrl.Tag) < bVal) {
                bVal = Convert.ToInt32(ctrl.Tag);
            }
            ctrl.Text = Convert.ToString(bVal, 10);
        }

        //==============================================================
        // TextBox: hexadecimal.
        //  key pressed.
        //==============================================================
        private void e16_kp(object sender, KeyPressEventArgs e)
        {
            if ('0' <= e.KeyChar && e.KeyChar <= '9') {
                return;
            }
            if ('A' <= e.KeyChar && e.KeyChar <= 'F') {
                return;
            }
            if ('a' <= e.KeyChar && e.KeyChar <= 'f') {
                return;
            }
            if (e.KeyChar < ' ') {
                return;
            }
            e.Handled = true;
        }

        //==============================================================
        // TextBox: hexadecimal.
        //  lost focus.
        //==============================================================
        private void e16_lf(TextBox ctrl)
        {
            string  st;

            st = "";
            for (int ii = 0; ii < ctrl.MaxLength; ii++) {
                st += '0';
            }

            if (1 > ctrl.Text.Length) {
                ctrl.Text = st;

                return;
            }

            st += ctrl.Text;
            ctrl.Text = st.Substring(st.Length - ctrl.MaxLength, ctrl.MaxLength);
        }

        //==============================================================
        // TextBox
        //  lost focus.
        //==============================================================
        private void textBoxFiltersetCmdWrite_Leave(object sender, EventArgs e)
        {
            e10_lf(textBoxFiltersetCmdWrite);
        }

        private void textBoxPortprmCmdBm_Leave(object sender, EventArgs e)
        {
            e16_lf(textBoxPortprmCmdBm);
        }

        private void textBoxPortprmCmdBd_Leave(object sender, EventArgs e)
        {
            e16_lf(textBoxPortprmCmdBd);
        }

        private void textBoxOutputCmdBd_Leave(object sender, EventArgs e)
        {
            e16_lf(textBoxOutputCmdBd);
        }

        private void textBoxWdtToutdatCmdBd_Leave(object sender, EventArgs e)
        {
            e16_lf(textBoxWdtToutdatCmdBd);
        }
    }
}
