/*	elog.h

	output log to edit control.

	Copyright (C) CPI Technologies, Inc.
*/

#ifndef	ELOG_H	/*[*/
#define	ELOG_H	1

#pragma	warning( disable: 4115 4201 4214 4514 )
#include <windows.h>
#pragma	warning( 1: 4115 4201 4214 )
#include <tchar.h>

#ifdef	__cplusplus
extern	"C"
{
#endif

/*//////////////////////////////////////////////////////////////////////
*/

typedef	struct	/* log control information */
{
	BOOL	fCre;	/* he is CreateWindow'ed */
	HWND	he;	/* log edit control */
	HFONT	h0f;	/* original font */
	HFONT	hf;	/* new fixed width font */
}	TELOG;

typedef	TELOG FAR*	HELOG;

/*//////////////////////////////////////////////////////////////////////
*/

BOOL WINAPI el_clo( HELOG hl );
HELOG WINAPI el_cre( HWND hwP, int x, int y, int nW, int nH, long nF );
HELOG WINAPI el_cat( HWND heL, long nF );
void WINAPI el_clr( HELOG hl );

void WINAPI el_outsA( HELOG hl, LPCSTR psz );
void WINAPI el_putsA( HELOG hl, LPCSTR psz );
void WINAPI el_vputfA( HELOG hl, LPCSTR pszForm, va_list vl );
void _cdecl el_putfA( HELOG hl, LPCSTR pszForm, ... );

void WINAPI el_outsW( HELOG hl, LPCWSTR psz );
void WINAPI el_putsW( HELOG hl, LPCWSTR psz );
void WINAPI el_vputfW( HELOG hl, LPCWSTR pszForm, va_list vl );
void _cdecl el_putfW( HELOG hl, LPCWSTR pszForm, ... );

#ifdef	_MBCS	/*[*/
#define	el_outs		el_outsA
#define	el_puts		el_putsA
#define	el_vputf	el_vputfA
#define	el_putf		el_putfA
#else	/*][*/
#define	el_outs		el_outsW
#define	el_puts		el_putsW
#define	el_vputf	el_vputfW
#define	el_putf		el_putfW
#endif	/*]*/

#ifdef	__cplusplus
}
#endif

#endif	/*]*/
