//=======================================================================================================
//
// cpizxio.cs
//
// CPI-ZD132/232/332R}hNX
// ̃NXForm1partialNXłB
//
// Copyright (C) CPI Technologies, Inc.
//
//=======================================================================================================
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
#if DEBUG   //[
using System.Diagnostics;
#endif  //]
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO.Ports;
using System.IO;
using System.Threading;

namespace ns_zdx32
{
    public partial class Form1
    {
        //-----------------------------------------------------------------------------------------------
        // const
        //-----------------------------------------------------------------------------------------------
        // ڑ\ȍő僂W[
        public const int MAXMODULE = 0x40;
        //-----------------------------------------------------------------------------------------------
        // var
        //-----------------------------------------------------------------------------------------------
        private static Object hx = new Object();        // I/OubLO
        private XBlib xbl = null;
                                                        // m[he[u
        private XBlib.NE[] aNodes = new XBlib.NE[MAXMODULE];
        private int nNodes = 0;                         // m[h
        private int iNode = -1;                         // ݂̃m[h

        // ZigBeeMXe[^X
        private byte xbSt_nRetry = 0;                   // s
        private byte xbSt_stDelivery = 0;               // foXe[^X
        private byte xbSt_stDiscovery = 0;              // TXe[^X

#if DEBUG   //[
        public uint dbg_cUnexpected = 0;
        public uint dbg_cModemStatus = 0;
        public uint dbg_cReversed = 0;
        public uint dbg_cFType = 0;
        public uint dbg_cFId = 0;
        public uint dbg_cZbPkFType = 0;
        public uint dbg_cZbPkAddr = 0;
        public uint dbg_cZbSt = 0;
        public uint dbg_cZbFId = 0;
        public uint dbg_cZbAddr = 0;
        public uint dbg_cZbFType = 0;
        public uint dbg_cRatStNg = 0;
#endif  //]

        //-----------------------------------------------------------------------------------------------
        // Pt[M
        //    rx    :Mʂ
        // svȃt[͊Ă܂B
        // TODO
        //      ^ʖڂɃfBXpb`B
        //-----------------------------------------------------------------------------------------------
        private XBlib.RC zxRx(ref byte[] rx)
        {
            XBlib.RC rc = XBlib.RC.Success;
            for ( ; ; )
            {
                rc = xbl.rxApiFrame(ref rx);
                if (XBlib.RC.Success != rc)
                {
                    break;
                }
                if (XBee.ftRxAt == rx[0]
                        || XBee.ftRxZbSt == rx[0]
                        || XBee.ftRxZb == rx[0]
                        || XBee.ftRxRat == rx[0]
                        )
                {
                    break;
                }
                // ̃t[͊Ă܂B
#if DEBUG   //[
                if (XBee.ftRxMst == rx[0])
                {
                    dbg_cModemStatus++;
                }
                else
                {
                    dbg_cUnexpected++;
                }
#endif  //]
            }
            return rc;
        }
        //-----------------------------------------------------------------------------------------------
        // Pt[M
        //    rx    :Mʂ
        //    ft    :̃t[^Cvǂݎ܂œǂ݊Ă܂B
        //-----------------------------------------------------------------------------------------------
        private XBlib.RC zxRxFD(ref byte[] rx, byte ft)
        {
            for ( ; ; )
            {
                XBlib.RC rc;

                rc = zxRx(ref rx);
                if (XBlib.RC.Success != rc)
                {
                    return rc;
                }

                if (ft == rx[0] || xbl.fidCur() == rx[1])
                {
                    break;
                }

#if DEBUG   //[
                if (ft != rx[0])
                {
                    dbg_cFType++;
                }
                if (xbl.fidCur() != rx[1])
                {
                    dbg_cFId++;
                }
#endif  //]
            }
            return XBlib.RC.Success;
        }
        //-----------------------------------------------------------------------------------------------
        // ZigBeeMpPbgPt[M
        //    rx    :Mʂ
        //    ne    :̃m[hGgǂݎ܂œǂ݊Ă܂B
        //-----------------------------------------------------------------------------------------------
        private XBlib.RC znRxZbPk(ref byte[] rx, ref XBlib.NE ne)
        {
            for ( ; ; )
            {
                XBlib.RC rc;

                rc = zxRx(ref rx);
                if (XBlib.RC.Success != rc)
                {
                    return rc;
                }

                if ( XBee.ftRxZb == rx[0]
                        && ne.sn0 == rx[1]
                        && ne.sn1 == rx[2]
                        && ne.sn2 == rx[3]
                        && ne.sn3 == rx[4]
                        && ne.sn4 == rx[5]
                        && ne.sn5 == rx[6]
                        && ne.sn6 == rx[7]
                        && ne.sn7 == rx[8]
                        )
                {
                    break;
                }

#if DEBUG   //[
                if (XBee.ftRxZb != rx[0])
                {
                    dbg_cZbPkFType++;
                }
                else
                {
                    dbg_cZbPkAddr++;
                }
#endif  //]
            }
            return XBlib.RC.Success;
        }
        //-----------------------------------------------------------------------------------------------
        // ZigBeeMXe[^XM
        //-----------------------------------------------------------------------------------------------
        private XBlib.RC zbSt(ref byte[] rx, ref XBlib.NE ne)
        {
            xbSt_nRetry = rx[4];
            xbSt_stDelivery = rx[5];
            xbSt_stDiscovery = rx[6];

            if (XBee.zbdvSuccess != xbSt_stDelivery)
            {
#if DEBUG   //[
                dbg_cZbSt++;
#endif  //]
                //
                // ZigBeeMpPbg͎MȂ͂B
                //

                return XBlib.RC.TxZbFailed;
            }

            //
            // ZigBeeMpPbgM
            // ̃t[^Cvюw著Mm[hł͂Ȃ
            // t[͔j܂B
            //

            return znRxZbPk(ref rx, ref ne);
        }
        //-----------------------------------------------------------------------------------------------
        // ZigBeeMXe[^XMOZigBeeMpacketMꍇ
        //-----------------------------------------------------------------------------------------------
        private XBlib.RC zbPk()
        {
            byte[] rx = new byte[256];
            XBlib.RC rc;

            rc = zxRxFD(ref rx, XBee.ftRxZbSt);
            if (XBlib.RC.Success != rc)
            {
                return rc;
            }

            xbSt_nRetry = rx[4];
            xbSt_stDelivery = rx[5];
            xbSt_stDiscovery = rx[6];

#if DEBUG   //[

            //
            // ZigBeeMpPbgMς݂ƂƂ
            // ZigBeeMĂ͂
            //

            byte[] ab = new byte[1];
            ab[0] = xbSt_stDelivery;
            Debug.Assert(XBee.zbdvSuccess == xbSt_stDelivery,
                    "foXe[^Xُ "
                            + BitConverter.ToString(ab)
                    );

#endif  //]

            return XBlib.RC.Success;
        }
        //-----------------------------------------------------------------------------------------------
        // ZigBeeMXe[^XZigBeeMpPbgM
        //    tx        :M
        //    ߂l    :M
        // ǂɎMĂǂ
        //-----------------------------------------------------------------------------------------------
        private XBlib.RC zbRx(ref byte[] rx, ref XBlib.NE ne)
        {
            XBlib.RC rc;

            for ( ; ; )
            {
                rc = zxRx(ref rx);
                if (XBlib.RC.Success != rc)
                {
                    return rc;
                }

                if (XBee.ftRxZbSt == rx[0])
                {
                    if (xbl.fidCur() != rx[1])
                    {
#if DEBUG   //[
                        dbg_cZbFId++;
#endif  //]

                        continue;
                    }

                    rc = zbSt(ref rx, ref ne);
                    break;
                }
                else if (XBee.ftRxZb == rx[0])
                {
                    if (ne.sn0 != rx[1]
                            || ne.sn1 != rx[2]
                            || ne.sn2 != rx[3]
                            || ne.sn3 != rx[4]
                            || ne.sn4 != rx[5]
                            || ne.sn5 != rx[6]
                            || ne.sn6 != rx[7]
                            || ne.sn7 != rx[8]
                            )
                    {
#if DEBUG   //[
                        dbg_cZbAddr++;
#endif  //]

                        continue;
                    }

#if DEBUG   //[
                    dbg_cReversed++;
#endif  //]
                    rc = zbPk();
                    break;
                }
#if DEBUG   //[
                else
                {
                    dbg_cZbFType++;
                }
#endif  //]
            }
            return rc;
        }
        //-----------------------------------------------------------------------------------------------
        // 4.1.1ȍ~̃R}h̋ʏ
        // ZDR}hs
        //    tx        :M
        //    ߂l    :M
        //-----------------------------------------------------------------------------------------------
        private string exZb(string tx)
        {
            string rs = "";
            if (iNode < 0 || nNodes <= iNode)
            {
                return rs;
            }

            lock (hx)
            {
                                                        // ZD̃R}hM
                XBlib.RC rc = xbl.sendRequest(aNodes[iNode], tx + "\r");
                if (XBlib.RC.Success != rc)
                {
                    return rs;
                }

                byte[] rx = new byte[256];
                rc = zbRx(ref rx, ref aNodes[iNode]);
                if (XBlib.RC.Success != rc)
                {
                    return rs;
                }

                for (int ii = 12; ii < rx.Length; ii++)
                {
                    rs += (char)rx[ii];
                }
            }

            return rs;
        }
        //-----------------------------------------------------------------------------------------------
        // uATR}hs
        // Wrbg߂l
        //    tx        :M
        //    pbV       :MWrbgli[obt@
        //    ߂l    :"" G[
        //              :"00" 
        //-----------------------------------------------------------------------------------------------
        private string exRat(string tx, ref byte pbV)
        {
            string rs = "";
            if (iNode < 0 || nNodes <= iNode)
            {
                return rs;
            }

            lock (hx)
            {
                XBlib.RC rc = xbl.sendRemoteAT(tx, aNodes[iNode]);
                if (XBlib.RC.Success != rc)
                {
                    return rs;
                }

                byte[] rx = new byte[256];
                rc = zxRxFD(ref rx, XBee.ftRxRat);
                if (XBlib.RC.Success != rc || XBee.atstOk != rx[14])
                {
#if DEBUG   //[
                    if (XBee.atstOk != rx[14])
                    {
                        dbg_cRatStNg++;
                    }
#endif  //]

                    return rs;
                }

                pbV = rx[15];               // o
            }
            return "00";                    // I
        }
        //===============================================================================================
        // 3.1.  CPI-ZDR[fBl[^mF
        //===============================================================================================
        public string Zdlib_p3_1()
        {
            serialPort1.DiscardInBuffer();              // Mobt@̃f[^j

            string rs = "";

            XBlib.RC rc = xbl.atNI(ref rs);             // ATNIR}h
            if (XBlib.RC.Success != rc)
            {
                return "";
            }
            return rs;
        }
        //===============================================================================================
        // 3.2.  CPI-ZDjbg
        //===============================================================================================
        public string[] Zdlib_p3_2()
        {
            byte[] ATND = { 0x08, 0, (byte)'N', (byte)'D' };

            int rt0 = serialPort1.ReadTimeout;
            const int cmsTmoRead = 6000;                // TODO v`[jOH
            serialPort1.ReadTimeout = cmsTmoRead;
            lock (hx)
            {
                                                        // ATNDM
                XBlib.RC rc = xbl.txApiFrame(ATND, ATND.Length);
                if (XBlib.RC.Success != rc)
                {
                    return null;
                }

                byte[] rx = new byte[256];
                for (nNodes = 0; ; )
                {
                    rc = zxRxFD(ref rx, XBee.ftRxAt);   // M
                    if (XBlib.RC.Success != rc)
                    {
                        break;
                    }
                    if ('N' != rx[2] || 'D' != rx[3])   // NDR}ĥ
                    {
                        continue;
                    }

                                                        // m[hۑ
                    if (! xbl.neFromNd(ref aNodes[nNodes], rx))
                    {
                        continue;
                    }
                    nNodes++;
                }
            }

            serialPort1.ReadTimeout = rt0;
            string[] ni = new string[nNodes];
            for (int iN = 0; iN < nNodes; iN++)
            {
                ni[iN] = String.Format(
                        "{0:X08} {1:X08} {2}",
                        aNodes[iN].sh,
                        aNodes[iN].sl,
                        aNodes[iN].ni
                        );
            }

            return ni;
        }
        //===============================================================================================
        // 3.2a jbgw
        //===============================================================================================
        public bool Zdlib_p3_2a(int iN)
        {
            if (iN < nNodes)
            {
                iNode = iN;

                return true;
            }
            return false;
        }
        //===============================================================================================
        // 4.1.1.  ̓R}h
        //===============================================================================================
        public string Zdlib_InputCmd(string ip)
        {
            return exZb("IP " + ip);
        }
        //===============================================================================================
        // 4.1.2.  tB^ݒR}h
        //===============================================================================================
        public string Zdlib_FiltersetCmd(string fi, string rm)
        {
            return exZb("FS " + fi + " " + rm);
        }
        //===============================================================================================
        // 4.1.3.  |[gĎp[^ݒR}h
        //===============================================================================================
        public string Zdlib_PortprmCmd(string ip, string md, string bm, string bd)
        {
            return exZb("TC " + ip + " " + md + " " + bm + " " + bd);
        }
        //===============================================================================================
        // 4.1.4.  |[gĎԎ擾
        //===============================================================================================
        public string Zdlib_Portsts(string ip)
        {
            return exZb("TS " + ip);
        }
        //===============================================================================================
        // 4.2.1.  o̓R}h
        //===============================================================================================
        public string Zdlib_OutputCmd(string ip, string bd)
        {
            return exZb("OP " + ip + " " + bd);
        }
        //===============================================================================================
        // 4.2.2.  WDT^CAEgݒR}h
        //===============================================================================================
        public string Zdlib_WdtToutsetCmd(string to)
        {
            return exZb("WT " + to);
        }
        //===============================================================================================
        // 4.2.3.  WDTJE^ZbgR}h
        //===============================================================================================
        public string Zdlib_WdtCntresetCmd(int wtime)
        {
            return exZb("WR");
        }
        //===============================================================================================
        // 4.2.4.  WDT^CAEgo͒lݒR}h
        //===============================================================================================
        public string Zdlib_WdtToutdatCmd(string ip, string bd)
        {
            return exZb("WO " + ip + " " + bd);
        }
        //===============================================================================================
        // 4.2.5.  WDTXe[^X擾R}h
        //===============================================================================================
        public string Zdlib_WdtstsCmd(int wtime)
        {
            return exZb("WS");
        }
        //===============================================================================================
        // 4.2.6.  WDTXe[^XNAR}h
        //===============================================================================================
        public string Zdlib_WdtstsclrCmd(int wtime)
        {
            return exZb("WC");
        }
        //===============================================================================================
        // 4.2.7.  WDTo͒lNAR}h
        //===============================================================================================
        public string Zdlib_WdtToutclrCmd(int wtime)
        {
            return exZb("WZ");
        }
        //===============================================================================================
        // 4.3.1.  ŌɔG[R[h擾R}h
        //===============================================================================================
        public string Zdlib_LasterrCmd(int wtime)
        {
            return exZb("QE");
        }
        //===============================================================================================
        // 4.3.2.  t@[EFAo[W擾R}h
        //===============================================================================================
        public string Zdlib_FverCmd(int wtime)
        {
            return exZb("QV");
        }
        //===============================================================================================
        // 4.3.3.  jbgZNgXCb`ݒl擾R}h
        //===============================================================================================
        public string Zdlib_UnitselswCmd(int wtime)
        {
            return exZb("QR");
        }
        //===============================================================================================
        // 4.3.4.  jbg^Cv擾R}h
        //===============================================================================================
        public string Zdlib_UnittypeCmd(int wtime)
        {
            return exZb("QT");
        }
        //===============================================================================================
        // 4.3.5.  jbg擾R}h
        //===============================================================================================
        public string Zdlib_UnitnameCmd(int wtime)
        {
            return exZb("QI");
        }
        //===============================================================================================
        // 4.3.6.  NOPiTEST UNIT READYj
        //===============================================================================================
        public string Zdlib_Nop(int wtime)
        {
            return exZb("UR");
        }
        //===============================================================================================
        // 4.4.1.  dEx擾R}h
        //===============================================================================================
        public string Zdlib_Atdb(ref byte pbV)
        {
            return exRat("DB", ref pbV);
        }
    }
}
